package com.fs.course.service;

import java.util.List;
import com.fs.course.domain.FsCourseTrafficLog;
import com.fs.course.param.FsCourseTrafficLogParam;
import com.fs.course.param.InternetTrafficParam;
import com.fs.course.param.StatisticsSummaryParam;
import com.fs.course.vo.FsCourseTrafficLogListVO;
import com.fs.course.vo.StatisticsSummaryVO;

/**
 * 短链课程流量记录Service接口
 *
 * @author fs
 * @date 2024-10-31
 */
public interface IFsCourseTrafficLogService
{
    /**
     * 查询短链课程流量记录
     *
     * @param logId 短链课程流量记录主键
     * @return 短链课程流量记录
     */
    public FsCourseTrafficLog selectFsCourseTrafficLogByLogId(Long logId);

    /**
     * 查询短链课程流量记录列表
     *
     * @param fsCourseTrafficLog 短链课程流量记录
     * @return 短链课程流量记录集合
     */
    public List<FsCourseTrafficLog> selectFsCourseTrafficLogList(FsCourseTrafficLog fsCourseTrafficLog);

    /**
     * 新增短链课程流量记录
     *
     * @param fsCourseTrafficLog 短链课程流量记录
     * @return 结果
     */
    public int insertFsCourseTrafficLog(FsCourseTrafficLog fsCourseTrafficLog);

    /**
     * 修改短链课程流量记录
     *
     * @param fsCourseTrafficLog 短链课程流量记录
     * @return 结果
     */
    public int updateFsCourseTrafficLog(FsCourseTrafficLog fsCourseTrafficLog);

    /**
     * 批量删除短链课程流量记录
     *
     * @param logIds 需要删除的短链课程流量记录主键集合
     * @return 结果
     */
    public int deleteFsCourseTrafficLogByLogIds(Long[] logIds);

    /**
     * 删除短链课程流量记录信息
     *
     * @param logId 短链课程流量记录主键
     * @return 结果
     */
    public int deleteFsCourseTrafficLogByLogId(Long logId);


    List<FsCourseTrafficLogListVO> selectTrafficByCompany(FsCourseTrafficLogParam param);

    /**
     * 存储课程流量日志
     */
    void saveCourseTrafficLog();

    List<FsCourseTrafficLogListVO> selectTrafficNew(FsCourseTrafficLogParam param);


    void updateTrafficStatus(InternetTrafficParam internetTrafficParam);


    /**
     * 定时统计流量总数
     */
    void sumTrafficlog();

    /**
     * 流量统计汇总
     * @param param
     * @return
     */
    List<StatisticsSummaryVO> getStatisticsSummaryList(StatisticsSummaryParam param);
    /**
     * 获取流量统计列表（不分页）
     * @param param
     * @return
     */
    List<StatisticsSummaryVO> getStatisticsSummaryListNotPage(StatisticsSummaryParam param);

    void batchDelTraffic();
}
